//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  TImageList Ɋi[Ă摜擾
//  TIcon `̉摜ƂĎ擾Ă TBitmap ɕϊ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2019N0826 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows U64(SP1) + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  Vcl.ExtCtrls, Vcl.ImgList;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Image2: TImage;
    ImageList1: TImageList;
    ImageList2: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    FBackImgPath : string;
    procedure DrawBackGroundImage(ACanvas: TCanvas; AFilePath: string);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//  ߏԂ̊mFpɔwiwFœhׂ
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.Color   := $00B3FFB3;
  FBackImgPath := ExpandFileName('..\BackTexture_01.bmp');
end;

//=============================================================================
//  TImageList 摜 TBitmap 摜ƂĎ擾
//  Assign  TCanvas.Draw ̗ŕ`挋ʂmF
//
//  TIcon `̉摜ƂĎ擾Ă TBitmap ɕϊ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LIcon : TIcon;
  LBitmap : TBitmap;
begin
  Image1.Picture.Assign(nil);
  Image2.Picture.Assign(nil);

  //ߏԂ悤ɔwiɎs͗l̃rbg}bv摜`
  DrawBackGroundImage(Image1.Canvas, FBackImgPath);
  DrawBackGroundImage(Image2.Canvas, FBackImgPath);


  LIcon := TIcon.Create;
  LBitmap := TBitmap.Create;
  try
    // TIcon ƂĎ擾
    ImageList1.GetIcon(1, LIcon);

    // TIcon --> TBitmap ϊ
    if ImageList1.ColorDepth = cd32Bit then begin
      LIcon.AssignTo(LBitmap);
    end else begin
      LBitmap.Transparent := True;
      LBitmap.SetSize(LIcon.Width, LIcon.Height);
      LBitmap.Canvas.Draw(0, 0, LIcon);
    end;

    Image1.Picture.Assign(LBitmap);
    Image2.Canvas.Draw(0, 0, LBitmap);
  finally
    FreeAndNil(LIcon);
    FreeAndNil(LBitmap);
  end;
end;

//----------------------------------------------------------------------------
//  TImage ̔wiƂĎs͗l̃uV`
//  TBitmap ̓ߐFƔF̊mFp
//  ̖͗l镔͓܂͔̕ƂƂɂȂ
//----------------------------------------------------------------------------
procedure TForm1.DrawBackGroundImage(ACanvas: TCanvas; AFilePath: string);
var
  LBmpBack : TBitmap;
begin
  LBmpBack := TBitmap.Create;
  try
    LBmpBack.LoadFromFile(AFilePath);
    ACanvas.Brush.Style  := bsSolid;
    ACanvas.Brush.Bitmap := LBmpBack;
    ACanvas.FillRect(ACanvas.ClipRect);
  finally
    FreeAndNil(LBmpBack);
  end;
end;

end.
